from sage.all import *

from public_parameters_generation import *
from key_encapsulation import *
from montgomery_arithmetics import *
from utilities.supersingular import *
from compressed import *


p = 2**(774)*3*5**(111)*11*122-1



Fp = GF(p)

Fp2 = GF(p**2, name='sqrtminus', modulus = x**2+1)

Fp2.inject_variables()



c = 774

a = 488

b = 111

ell = 11

elligator_tables = precompute_elligator_tables(Fp2)
compressed = 1


strategy = optimal_strategy_5(b,17,11)

gamma = generate_gamma(c,a,b,ell,p,Fp,Fp2)

pub_param = generate_publicparameters(c,a,b,ell,gamma,p,Fp,Fp2,sqrtminus)

print("Public parameters generation: Done")

Alice_pub,Alice_secret = Alice_keygen(c,a,pub_param,p,Fp,Fp2)
if compressed == 1:
    Alice_pub_comp = compressed_pubkey(Alice_pub,b,c,elligator_tables,p,Fp,Fp2)

print("Public key generation: Done")

if compressed == 1:
    Alice_pub = decomp_pubkey(Alice_pub_comp,b,c,elligator_tables,p,Fp,Fp2)

Bob_pub,Bob_sharedkey = Bob_keygen(c,b,pub_param,Alice_pub,strategy,p,Fp,Fp2)

if compressed == 1:
    Bob_pub_comp = compressed_cipher(Bob_pub,c,elligator_tables,p,Fp,Fp2)


print("Encapsulation: Done")

if compressed == 1:
    Bob_pub = decomp_cipher(Bob_pub_comp,Alice_secret,a,b,c,ell,elligator_tables, p,Fp,Fp2)
Alice_sharedkey = Alice_shared_check(c,a,ell,Bob_pub,Alice_secret,p,Fp,Fp2,compressed)


if compressed == 1:
    Bob_pub = decomp_cipher(Bob_pub_comp,Alice_secret,a,b,c,ell,elligator_tables, p,Fp,Fp2)
Alice_sharedkey2 = Alice_shared(c,a,ell,Bob_pub,Alice_secret,p,Fp,Fp2,compressed)

print("Decapsulation: Done")

if Bob_sharedkey == Alice_sharedkey:
    print("Success")
else:
    print("Suffering")
